function m=totdev(params,dists,seeds,errortype,fitborder,bordertype,circlerad)
% totdev IS THE TOTAL SQUARED ERROR 
% BETWEEN EXPECTED AND ACTUAL SEED DENSITIES
% OR TOTAL NEGATIVE LOG LIKELIHOOD of ACTUAL GIVEN EXPECTED VALUES
% WHERE EXPECTED DENSITIES ARE CALCULATED GIVEN params

  cdisp=params(1);
  kfecund=params(2);
  
  maxn = length(dists);
  % depending on whether the location of the border is being estimated or not:
  if (fitborder==0)
      border=0;
  else
      border=params(3);
  end
  
  % depending on the error type
  if (errortype==2) 
    if (fitborder==0)
        nbk=params(3);
    else
        nbk=params(4);
    end
  end
  m=0; 
  
  if (kfecund<0 | ((fitborder==1) & (border<min(dists)-10|border>max(dists))))
    m=100000;
  else 
    for n=1:maxn
        % the actual number of seeds at this point
        s=seeds(n);
        
        % calculate the expected number of seeds at this point
        r = sdposint(dists(n)-border,cdisp,kfecund,bordertype,circlerad);
        
        % least-squares after logging data:
        if (errortype==0)
        thism= ( log(r+0.1)-log(s+0.1) )^2 ;
    
        % Poisson negative log-likelihood (because to be minimized)
        elseif (errortype==1)
        if (s==0 & r==0)
            thism=0;
        elseif (s>0 & r==0)
            thism=1000;
        else
            thism = r - s*log(r) + gammaln(s+1);
        end    %altm = ln(poisspdf(s,r));
        
        % negative binomial negative log-likelihood
        elseif (errortype==2)
        thism = -gammaln(nbk+s) + gammaln(nbk) + gammaln(s+1) - nbk*log(nbk) - s*log(r) + (nbk+s)*log(nbk+r);
        
        end
        
        m=m+thism;
    end
  end
  
  if (fitborder==0 & errortype<2)
    sprintf('dispersal c=%g, fecundity k=%g, totdev=%g',params(1),params(2),m)
  elseif (fitborder==0 & errortype==2)
    sprintf('dispersal c=%g, fecundity k=%g, nbk=%g, totdev=%g',params(1),params(2),params(3),m)
  elseif (fitborder==1 & errortype<2)
    sprintf('dispersal c=%g, fecundity k=%g, distance d=%g, totdev=%g',params(1),params(2),params(3),m)
  elseif (fitborder==1 & errortype==2)
    sprintf('dispersal c=%g, fecundity k=%g, distance d=%g, nbk=%g, totdev=%g',params(1),params(2),params(3),params(4),m)
  end
  
